using Exferia_Aplicacion.Herencia.Capas;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Exferia_Aplicacion.General;
using Exferia_EntityFramework;
using System.Runtime.CompilerServices;
using Exferia_General;
using Exferia_Contabilidad._0_Modelos;
using Exferia_Aplicacion.Modelos_MantenimientoSimple;
using System.Transactions;
using System.Data.SqlClient;
using System.Data.Objects.SqlClient;
using static Exferia_Aplicacion.General.Enumerados;

namespace Exferia_Contabilidad._1_Datos
{
    public class CTA_ClavesAnaliticas_Datos : ABS_Datos
    {
        #region Listado
        private List<INTERNO_CTA_ClavesAnaliticas_Listado_Modelo> g_lst_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo = null;

        public override List<dynamic> Obtener_Listado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            List<dynamic> lst_CTA = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CTA_ClavesAnaliticas).Name), _lst_CamposConRelacionABuscar, -1,null, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo != null) && (g_lst_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.Count() > 0))
                {
                    lst_CTA = g_lst_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(Obtener_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return lst_CTA;
        }
        public override dynamic Obtener_RegistroListado(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_CTA = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                // Consulta .....................................................
                ConsultaRellenar_Listado(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CTA_ClavesAnaliticas).Name), _lst_CamposConRelacionABuscar, _lng_id, _lst_ids, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if ((g_lst_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo != null) && (g_lst_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.Count() > 0))
                {
                    dnm_CTA = g_lst_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.Cast<dynamic>().ToList();
                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(Obtener_RegistroListado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_CTA;
        }

        protected override void ConsultaRellenar_Listado(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                string str_Filtros_Empresa = Funciones.Formar_ContenidoIN_ParaConsultaWhere(_lst_idEmpresasRelacionas);

                //Filtros de Opciones
                //Datos del Padre si los tuviera .........................
                long lng_Padre_id = -1;
                string str_Padre_Opcion = "";
                if (_lst_INTERNO_Filtro_OpcionPadre_Modelo != null && _lst_INTERNO_Filtro_OpcionPadre_Modelo.Count > 0)
                {
                    lng_Padre_id = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].VALOR;
                    str_Padre_Opcion = _lst_INTERNO_Filtro_OpcionPadre_Modelo[0].NOMBRE_CAMPO;
                }


                string str_SQL =
                    " SELECT " +
                        //CTA_ClavesAnaliticas
                        nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.id) + " = " + nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.id) + "," +
                        nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.codigo) + " = " + nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.codigo) + "," +
                        nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.descripcion) + " = " + nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.descripcion) + "," +
                        nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.idEmpresa) + " = " + nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.idEmpresa) + "," +
                        //Empresa
                        (
                            (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.Empresa)))
                            ?
                                (
                                    nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.Empresa_Codigo) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.codigo) + "," +
                                    nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.Empresa_Descripcion) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.descripcion) + "," +
                                    nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.Empresa_FechaBorrado) + " = " + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.fechaBorrado)
                                )
                            :
                                (
                                    nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.Empresa_Codigo) + " = ''," +
                                    nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.Empresa_Descripcion) + "= '', " +
                                    nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.Empresa_FechaBorrado) + " = NULL "
                                )
                        ) +
                " FROM " + nameof(CTA_ClavesAnaliticas) +
                //Empresa
                (
                    (_lst_CamposConRelacionABuscar.Contains(nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.Empresa)))
                    ?
                        (
                            " LEFT JOIN " + nameof(GEN_Empresas) + " ON " + nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.idEmpresa) + "=" + nameof(GEN_Empresas) + "." + nameof(GEN_Empresas.id)
                        )
                    : ("")
                ) +
               " WHERE " + nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.fechaBorrado) + " IS null AND " +
                           " ( " + nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.idEmpresa) + "=@idEmpresa " +
                                (
                                    (_lst_idEmpresasRelacionas != null && _lst_idEmpresasRelacionas.Count > 0)
                                        ? (" OR " + nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.idEmpresa) + " in (" + str_Filtros_Empresa + ") ")
                                        : " "
                                ) +
                            " ) AND " +
                          (
                         (_lng_id > -1)
                             ? (nameof(CTA_ClavesAnaliticas.id) + " = " + _lng_id)
                             : " 1 = 1  "
                          )
                          + " AND " +
                          //Filtro por datos del padre relacionado
                          (
                              !str_Padre_Opcion.Equals("")
                                  //Empresa
                                  ? str_Padre_Opcion.Equals(Variables.G_STR_OPCION_GEN_EMPRESA)
                                      ? (nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.idEmpresa) + "=@id_Padre")
                                      : ("1 = 1")
                                  : ("1 = 1")
                         );


                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresaSeleccionada));
                lst_Parametros.Add(new SqlParameter("@id_Padre", lng_Padre_id));

                object[] arr_Parametros = lst_Parametros.ToArray();


                //Rellenar el Modelo
                g_lst_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTA_ClavesAnaliticas_Listado_Modelo>(str_SQL, arr_Parametros).ToList();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(ConsultaRellenar_Listado), true);
            }
        }
        #endregion

        #region Listado Secundario
        public override List<dynamic> Obtener_Listado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            return null;
        }
        public override dynamic Obtener_RegistroListado_Secundario(long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<string> _lst_CamposConRelacionABuscar, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo, long _lng_id, List<long> _lst_ids)
        {
            return null;
        }
        protected override void ConsultaRellenar_Listado_Secundario(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionadas, List<string> _lst_CamposConRelacionABuscar, long _lng_id, List<long> _lst_ids, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        { }
        #endregion

        #region F3
        private INTERNO_CTA_ClavesAnaliticas_Listado_Modelo g_mdl_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo_F3 = null;

        public override dynamic Obtener_F3(string _str_filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_CTA = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Consulta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CTA_PredefinidosConceptos).Name), _str_CampoBusqueda, _str_filtro, -1, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo_F3 != null)
                {
                    dnm_CTA = g_mdl_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo_F3;
                }
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(Obtener_F3), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_CTA;
        }
        public override dynamic Obtener_F3_PorId(long _lng_id, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            dynamic dnm_CTA = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Conuslta ......................................................
                ConsultaRellenar_F3(obj_Exferia_Entities, _lng_idEmpresaSeleccionada, _lng_idEjercicioActual, Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresaSeleccionada, typeof(CTA_ClavesAnaliticas).Name), "", "", _lng_id, _lst_INTERNO_Filtro_OpcionPadre_Modelo, _lst_INTERNO_Filtro_Modelo);
                // ..............................................................

                if (g_mdl_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo_F3 != null)
                {
                    dnm_CTA = g_mdl_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo_F3;
                }

            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(Obtener_F3_PorId), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return dnm_CTA;
        }

        protected override void ConsultaRellenar_F3(Exferia_Entities _obj_Exferia_Entities, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual, List<long> _lst_idEmpresasRelacionas, string _str_CampoBusqueda, string _str_Filtro, long _lng_id, List<INTERNO_Filtro_OpcionPadre_Modelo> _lst_INTERNO_Filtro_OpcionPadre_Modelo, List<INTERNO_Filtro_Modelo> _lst_INTERNO_Filtro_Modelo)
        {
            try
            {
                string str_SQL =
                    " SELECT distinct " +
                        nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.id) + " = " + nameof(CTA_ClavesAnaliticas.id) + "," +
                        nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.codigo) + " = " + nameof(CTA_ClavesAnaliticas.codigo) + "," +
                        nameof(INTERNO_CTA_ClavesAnaliticas_Listado_Modelo.descripcion) + " = " + nameof(CTA_ClavesAnaliticas.descripcion) +
                " FROM " + nameof(CTA_ClavesAnaliticas) +
                " WHERE " + nameof(CTA_ClavesAnaliticas.fechaBorrado) + " IS null AND " +
                        (
                          _lng_id > -1
                                ? (nameof(CTA_ClavesAnaliticas.id) + "=" + _lng_id)
                                : (
                                    //Filtrar por Codigo
                                    (_str_CampoBusqueda.Equals(nameof(CTA_ClavesAnaliticas.codigo)))
                                        ? (nameof(CTA_ClavesAnaliticas.codigo) + "=@Filtro")
                                        //Filtrar por Descripcion
                                        : (nameof(CTA_ClavesAnaliticas.descripcion) + "=@Filtro")
                                  )
                        );

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@Filtro",  _str_Filtro)
                };

                //Rellenar el Modelo
                g_mdl_INTERNO_CTA_ClavesAnaliticas_Listado_Modelo_F3 = _obj_Exferia_Entities.Database.SqlQuery<INTERNO_CTA_ClavesAnaliticas_Listado_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();

            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(ConsultaRellenar_F3), true);
            }
        }
        #endregion

        #region Obtener
        private dynamic g_dnm_Modelo_Obtener = null;
        public override dynamic Obtener(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                string str_SQL =
                           " SELECT distinct " +
                              nameof(INTERNO_MantenimientoSimple_Modelo.id) + " = " + nameof(CTA_ClavesAnaliticas.id) + "," +
                              nameof(INTERNO_MantenimientoSimple_Modelo.codigo) + " = " + nameof(CTA_ClavesAnaliticas.codigo) + "," +
                              nameof(INTERNO_MantenimientoSimple_Modelo.descripcion) + " = " + nameof(CTA_ClavesAnaliticas.descripcion) + "," +
                              nameof(INTERNO_MantenimientoSimple_Modelo.Auxiliar_1) + " = case when " + nameof(CTA_ClavesAnaliticas.presupuesto) + " is null then convert(varchar(50)," + nameof(CTA_ClavesAnaliticas.presupuesto) + ") else '' end ," +
                              nameof(INTERNO_MantenimientoSimple_Modelo.fechaBorrado) + " = " + nameof(CTA_ClavesAnaliticas.fechaBorrado) + "," +
                              nameof(INTERNO_MantenimientoSimple_Modelo.idEmpresa) + " = " + nameof(CTA_ClavesAnaliticas.idEmpresa) +
                           " FROM " + nameof(CTA_ClavesAnaliticas) +
                           " WHERE " + nameof(CTA_ClavesAnaliticas.fechaBorrado) + " IS null AND " +
                                  nameof(CTA_ClavesAnaliticas.id) + "=@id ";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Rellenar el Modelo
                g_dnm_Modelo_Obtener = obj_Exferia_Entities.Database.SqlQuery<INTERNO_MantenimientoSimple_Modelo>(str_SQL, arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(Obtener), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return g_dnm_Modelo_Obtener;
        }
        public override dynamic Obtener_Registro_PorCampo(string _str_Filtro, string _str_CampoBusqueda, long _lng_idEmpresaSeleccionada, long _lng_idEjercicioActual)
        {
            throw new NotImplementedException();
        }

        #endregion

        #region MODELOS

        #region Modelo Simple
        private CTA_ClavesAnaliticas g_mdl_CTA_ClavesAnaliticas = null;
        public CTA_ClavesAnaliticas Obtener_Modelo_Por_Id(long _lng_id)
        {
            try
            {
                string str_SQL = Obtener_Consulta_Modelo() +
                                  //WHERE
                                  " WHERE " + nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.id) + "=@id";

                //Parametros
                object[] arr_Parametros = new object[]
                {
                     new SqlParameter("@id",  _lng_id)
                };

                //Ejecutar y rellenar el modelo
                Ejecutar_Consulta_Modelo(str_SQL,
                                         arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(Obtener_Modelo_Por_Id), true);
            }

            return g_mdl_CTA_ClavesAnaliticas;
        }

        private void Ejecutar_Consulta_Modelo(string _str_SQL,
                                              object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                //Rellenar el Modelo
                g_mdl_CTA_ClavesAnaliticas = obj_Exferia_Entities.Database.SqlQuery<CTA_ClavesAnaliticas>(_str_SQL, _arr_Parametros).FirstOrDefault();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }

        #endregion

        #region Modelo Listado
        private List<CTA_ClavesAnaliticas> g_lst_CTA_ClavesAnaliticas = null;

        public List<CTA_ClavesAnaliticas> Obtener_ModeloListado_Por_idEmpresa(long _lng_idEmpresa)
        {
            try
            {
                List<SqlParameter> lst_Parametros = new List<SqlParameter>();

                List<long> lst_idEmpresasRelacionadas = Datos_Generales.GEN_Empresas_Devolver_EmpresasCompartidas_SegunFichero(_lng_idEmpresa, typeof(CTA_ClavesAnaliticas).Name);
                string str_Filtros_Empresas = Funciones.Formar_ContenidoIN_ParaConsultaWhere(lst_idEmpresasRelacionadas);

                string str_SQL = Obtener_Consulta_Modelo() +
                                //WHERE
                                " WHERE " +
                                        " ( " +
                                            nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.idEmpresa) + " =@idEmpresa " +
                                            (lst_idEmpresasRelacionadas != null && lst_idEmpresasRelacionadas.Count > 0 ? " OR " + nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.idEmpresa) + " in (" + str_Filtros_Empresas + ") " : "") +
                                        " )";

                //Parametros
                lst_Parametros.Add(new SqlParameter("@idEmpresa", _lng_idEmpresa));
                object[] arr_Parametros = lst_Parametros.ToArray();

                //Ejecutar y rellenar el listado
                Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                arr_Parametros);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_idEmpresa), true);
            }

            return g_lst_CTA_ClavesAnaliticas;
        }

        public List<CTA_ClavesAnaliticas> Obtener_ModeloListado_Por_Ids(List<long> _lst_Ids)
        {
            try
            {

                if (_lst_Ids != null && _lst_Ids.Count > 0)
                {
                    string str_Filtros_IDS = Funciones.Formar_ContenidoIN_ParaConsultaWhere(nameof(CTA_ClavesAnaliticas),
                                                                                            nameof(CTA_ClavesAnaliticas.id),
                                                                                            G_ENUM_FORMARCONTENIDOIN_CONDICIONANTES.NADA,
                                                                                            _lst_Ids);

                    //Consulta
                    string str_SQL = Obtener_Consulta_Modelo() +
                                    " WHERE " + str_Filtros_IDS;

                    //Ejecutar y rellenar el listado
                    Ejecutar_Consulta_Modelo_Listado(str_SQL,
                                                     new object[] { });

                }
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(Obtener_ModeloListado_Por_Ids), true);
            }

            return g_lst_CTA_ClavesAnaliticas;
        }

        #region Ejecutar Consulta
        private void Ejecutar_Consulta_Modelo_Listado(string _str_SQL,
                                                      object[] _arr_Parametros)
        {
            Exferia_Entities obj_Exferia_Entities = null;
            try
            {
                //Conexion
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;


                //Rellenar el modelo
                g_lst_CTA_ClavesAnaliticas = obj_Exferia_Entities.Database.SqlQuery<CTA_ClavesAnaliticas>(_str_SQL, _arr_Parametros).ToList();
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(Ejecutar_Consulta_Modelo_Listado), true);
            }
            finally
            {
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
        }
        #endregion
        #endregion

        private string Obtener_Consulta_Modelo()
        {
            return
                " SELECT " +
                    nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.id) + " , " +
                    nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.codigo) + " , " +
                    nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.descripcion) + " , " +
                    nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.presupuesto) + " , " +
                    nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.idEmpresa) + " , " +
                    nameof(CTA_ClavesAnaliticas) + "." + nameof(CTA_ClavesAnaliticas.fechaBorrado) +
                " FROM " + nameof(CTA_ClavesAnaliticas);
        }
        #endregion

        #region Grabar
        public override INTERNO_ValorDevuelto_Modelo Grabar(object _mdl_obj)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;

            try
            {
                obj_Exferia_Entities = new Exferia_Entities();
                obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                INTERNO_MantenimientoSimple_Modelo mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar = (INTERNO_MantenimientoSimple_Modelo)_mdl_obj;
                CTA_ClavesAnaliticas mdl_CTA_ClavesAnaliticas_DatosViejos = new CTA_ClavesAnaliticas();

                // Ver si existe ######################################################################
                CTA_ClavesAnaliticas mdl_CTA_ClavesAnaliticas_Final = Obtener_Modelo_Por_Id(mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar.id);
                //######################################################################################       

                if (mdl_CTA_ClavesAnaliticas_Final != null)
                {
                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_MODIFICAR;

                    //Datos viejos para la trazabilidad
                    Funciones.CopiarPropiedadesObjetos(mdl_CTA_ClavesAnaliticas_Final, mdl_CTA_ClavesAnaliticas_DatosViejos, false, false);

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_CTA_ClavesAnaliticas_Final, mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar);

                    #region Update
                    string str_SQL_Update = " UPDATE " + nameof(CTA_ClavesAnaliticas) +
                                            " SET " +
                                                nameof(CTA_ClavesAnaliticas.codigo) + "=@codigo," +
                                                nameof(CTA_ClavesAnaliticas.descripcion) + "=@descripcion," +
                                                nameof(CTA_ClavesAnaliticas.idEmpresa) + "=@idEmpresa," +
                                                nameof(CTA_ClavesAnaliticas.presupuesto) + "=@presupuesto," +
                                                nameof(CTA_ClavesAnaliticas.fechaBorrado) + "=@fechaBorrado " +
                                            " WHERE " +
                                                nameof(CTA_ClavesAnaliticas.id) + "=@id";
                    //Parametros
                    object[] arr_Parametros_Update = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_CTA_ClavesAnaliticas_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_CTA_ClavesAnaliticas_Final.descripcion),
                        new SqlParameter("@idEmpresa",  mdl_CTA_ClavesAnaliticas_Final.idEmpresa),
                        mdl_CTA_ClavesAnaliticas_Final.presupuesto!=null
                            ?   new SqlParameter("@presupuesto", mdl_CTA_ClavesAnaliticas_Final.presupuesto.Value)
                            :   new SqlParameter("@presupuesto",  DBNull.Value),
                        mdl_CTA_ClavesAnaliticas_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_CTA_ClavesAnaliticas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value),
                        new SqlParameter("@id",  mdl_CTA_ClavesAnaliticas_Final.id)
                    };
                    #endregion

                    //Update
                    obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = mdl_CTA_ClavesAnaliticas_Final.id;
                }
                else
                {
                    mdl_CTA_ClavesAnaliticas_Final = new CTA_ClavesAnaliticas();

                    //Tipo de Accion que se va a realizar
                    mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_INSERTAR;

                    //Cargar los Datos del Modelo
                    Cargar_DatosModelo(mdl_CTA_ClavesAnaliticas_Final, mdl_INTERNO_MantenimientoSimple_Modelo_AGrabar);

                    #region INSERT
                    string str_SQL_Insert = " INSERT INTO " + nameof(CTA_ClavesAnaliticas) +
                                                " (" +
                                                        nameof(CTA_ClavesAnaliticas.codigo) + "," +
                                                        nameof(CTA_ClavesAnaliticas.descripcion) + "," +
                                                        nameof(CTA_ClavesAnaliticas.idEmpresa) + "," +
                                                        nameof(CTA_ClavesAnaliticas.presupuesto) + "," +
                                                        nameof(CTA_ClavesAnaliticas.fechaBorrado) +
                                                " ) " +
                                                " OUTPUT INSERTED." + nameof(CTA_ClavesAnaliticas.id) +
                                                " VALUES " +
                                                " ( " +
                                                    "@codigo," +
                                                    "@descripcion," +
                                                    "@idEmpresa," +
                                                    "@presupuesto," +
                                                    "@fechaBorrado" +
                                                " ) ";
                    //Parametros
                    object[] arr_Parametros_Insert = new object[]
                    {
                        new SqlParameter("@codigo",  mdl_CTA_ClavesAnaliticas_Final.codigo),
                        new SqlParameter("@descripcion",  mdl_CTA_ClavesAnaliticas_Final.descripcion),
                        new SqlParameter("@idEmpresa",  mdl_CTA_ClavesAnaliticas_Final.idEmpresa),
                        mdl_CTA_ClavesAnaliticas_Final.presupuesto!=null
                            ?   new SqlParameter("@presupuesto", mdl_CTA_ClavesAnaliticas_Final.presupuesto.Value)
                            :   new SqlParameter("@presupuesto",  DBNull.Value),
                        mdl_CTA_ClavesAnaliticas_Final.fechaBorrado!=null
                            ?   new SqlParameter("@fechaBorrado", mdl_CTA_ClavesAnaliticas_Final.fechaBorrado.Value)
                            :   new SqlParameter("@fechaBorrado",  DBNull.Value)

                    };
                    #endregion

                    //Id de la tabla
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = obj_Exferia_Entities.Database.SqlQuery<long>(str_SQL_Insert, arr_Parametros_Insert).Single();
                }

                // Grabar un registro de trazabilidad con los datos de la transaccion realizada.
                Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTA_ClavesAnaliticas), mdl_CTA_ClavesAnaliticas_DatosViejos, mdl_CTA_ClavesAnaliticas_Final, mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion, obj_Exferia_Entities);
            }
            catch (Control_Errores)
            {
                throw;
            }
            catch (Exception ex)
            {
                throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(Grabar), true);
            }
            finally
            {
                //Finalizar transaccion
                obj_Exferia_Entities.Database.Connection.Close();
                obj_Exferia_Entities.Dispose();
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        private void Cargar_DatosModelo(CTA_ClavesAnaliticas _mdl_CTA_ClavesAnaliticas, INTERNO_MantenimientoSimple_Modelo _mdl_INTERNO_MantenimientoSimple_Modelo)
        {
            // Cargar los Datos Nuevos del Modelo
            _mdl_CTA_ClavesAnaliticas.id = _mdl_INTERNO_MantenimientoSimple_Modelo.id;
            _mdl_CTA_ClavesAnaliticas.codigo = _mdl_INTERNO_MantenimientoSimple_Modelo.codigo;
            _mdl_CTA_ClavesAnaliticas.descripcion = _mdl_INTERNO_MantenimientoSimple_Modelo.descripcion;
            if (_mdl_INTERNO_MantenimientoSimple_Modelo.Auxiliar_1.Trim().Length > 0)
            {
                _mdl_CTA_ClavesAnaliticas.presupuesto = Convert.ToDecimal(_mdl_INTERNO_MantenimientoSimple_Modelo.Auxiliar_1.Trim());
            }
            _mdl_CTA_ClavesAnaliticas.idEmpresa = _mdl_INTERNO_MantenimientoSimple_Modelo.idEmpresa;
        }
        #endregion

        #region Borrar
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id)
        {
            Exferia_Entities obj_Exferia_Entities = null;

            INTERNO_ValorDevuelto_Modelo mdl_INTERNO_ValorDevuelto_Modelo = new INTERNO_ValorDevuelto_Modelo();
            mdl_INTERNO_ValorDevuelto_Modelo.TodoCorrecto = true;
            //Tipo de Accion que se va a realizar
            mdl_INTERNO_ValorDevuelto_Modelo.TipoAccion = Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR;

            bool bol_ActualizarFechaBorrado = false;//Este campo se utiliza por si no se puede borrar, que actualice la fecha de borrado

            using (TransactionScope transaccion_SQL = new TransactionScope(TransactionScopeOption.Required))
            {
                try
                {
                    obj_Exferia_Entities = new Exferia_Entities();
                    obj_Exferia_Entities.Configuration.LazyLoadingEnabled = false;

                    // Ver si existe ######################################################################
                    CTA_ClavesAnaliticas mdl_CTA_ClavesAnaliticas_Final = Obtener_Modelo_Por_Id(_lng_id);
                    //######################################################################################

                    if (mdl_CTA_ClavesAnaliticas_Final != null)
                    {
                        //Se intenta borrar, si diera un error porque esta relacionado se graba la fecha de baja
                        try
                        {
                            #region Delete
                            string str_SQL_Delete = " DELETE FROM  " + nameof(CTA_ClavesAnaliticas) +
                                                    " WHERE " +
                                                        nameof(CTA_ClavesAnaliticas.id) + "=@id";
                            //Parametros
                            object[] arr_Parametros_Delete = new object[]
                            {
                                new SqlParameter("@id", _lng_id)
                            };
                            #endregion

                            //Delete
                            obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Delete, arr_Parametros_Delete);

                            //Grabar un registro de trazabailidad con los datos de la transaccion realizada.
                            Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTA_ClavesAnaliticas), null, mdl_CTA_ClavesAnaliticas_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                        }
                        catch (Exception ex)
                        {
                            var sqlException = ex.GetBaseException() as SqlException;
                            if (sqlException != null)
                            {
                                if (sqlException.Errors.Count > 0)
                                {
                                    switch (sqlException.Errors[0].Number)
                                    {
                                        case Control_Errores.G_INT_ERRORCONTROLADO_BORRAR_CONFLICTO_CLAVEFORANEA: // Foreign Key violation
                                            bol_ActualizarFechaBorrado = true;
                                            break;
                                        default:
                                            throw;
                                    }
                                }
                            }
                            else
                            {
                                throw;
                            }
                        }

                        //Actualizar la fecha de baja, al no poder borrarlo por tener relaciones
                        if (bol_ActualizarFechaBorrado)
                        {
                            #region Update
                            string str_SQL_Update = " UPDATE " + nameof(CTA_ClavesAnaliticas) +
                                                        " SET " +
                                                        nameof(CTA_ClavesAnaliticas.fechaBorrado) + "=@fechaBorrado " +
                                                    " WHERE " +
                                                        nameof(CTA_ClavesAnaliticas.id) + "=@id";
                            //Parametros
                            object[] arr_Parametros_Update = new object[]
                            {
                                 new SqlParameter("@fechaBorrado",  DateTime.Now),
                                new SqlParameter("@id", _lng_id)
                            };
                            #endregion

                            //Update
                            obj_Exferia_Entities.Database.ExecuteSqlCommand(str_SQL_Update, arr_Parametros_Update);

                            //Grabar un registro de trazabilidad con los datos de la trasaccion realizada
                            Datos_Generales.USR_Trazabilidad_Grabar(typeof(CTA_ClavesAnaliticas), null, mdl_CTA_ClavesAnaliticas_Final, Enumerados.G_ENUM_TIPOACCION.INT_ELIMINAR, obj_Exferia_Entities);
                        }
                    }

                    //Devolver tambien el Objeto
                    mdl_INTERNO_ValorDevuelto_Modelo.Id = _lng_id;

                    // se termina la Trasaccion Correctamente
                    transaccion_SQL.Complete();
                }
                catch (Control_Errores)
                {
                    throw;
                }
                catch (Exception ex)
                {
                    throw new Control_Errores("", ex, nameof(CTA_ClavesAnaliticas_Datos) + "/" + nameof(Borrar), true);
                }
                finally
                {
                    obj_Exferia_Entities.Database.Connection.Close();
                    obj_Exferia_Entities.Dispose();

                    // Finalizar transaccion
                    transaccion_SQL.Dispose();
                }
            }
            return mdl_INTERNO_ValorDevuelto_Modelo;
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(long _lng_id, long _lng_idAuxiliar)
        {
            throw new NotImplementedException();
        }
        public override INTERNO_ValorDevuelto_Modelo Borrar(object _mdl_obj)
        {
            return null;
        }
        #endregion
    }
}
